<?xml version="1.0" encoding="UTF-8"?>
<ecore:EPackage xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
    xmlns:ecore="http://www.eclipse.org/emf/2002/Ecore" name="simplepdl" nsURI="http://simplepdl" nsPrefix="simplepdl">
  <eAnnotations source="http://www.eclipse.org/OCL/Import">
    <details key="ecore" value="http://www.eclipse.org/emf/2002/Ecore"/>
  </eAnnotations>
  <eAnnotations source="http://www.eclipse.org/emf/2002/Ecore">
    <details key="invocationDelegates" value="http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot"/>
    <details key="settingDelegates" value="http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot"/>
    <details key="validationDelegates" value="http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot"/>
  </eAnnotations>
  <eClassifiers xsi:type="ecore:EEnum" name="WorkSequenceType">
    <eLiterals name="startToStart"/>
    <eLiterals name="finishToStart" value="1"/>
    <eLiterals name="startToFinish" value="2"/>
    <eLiterals name="finishToFinish" value="3"/>
  </eClassifiers>
  <eClassifiers xsi:type="ecore:EClass" name="Process">
    <eAnnotations source="http://www.eclipse.org/emf/2002/Ecore">
      <details key="constraints" value="noEmptyName deuxActivitesNomDifferent"/>
    </eAnnotations>
    <eAnnotations source="http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot">
      <eAnnotations source="http://www.eclipse.org/emf/2002/GenModel">
        <details key="documentation" value="TP3 Ex 1.3. qu 1. deux activités différentes d’un même processus ne peuvent pas avoir le même nom :"/>
      </eAnnotations>
      <details key="noEmptyName" value=" (not self.name.oclIsUndefined()) and self.name.size() > 0"/>
      <details key="deuxActivitesNomDifferent" value="processElement->select(p | p.oclIsTypeOf(WorkDefinition))->forAll(a1 : WorkDefinition, a2 : WorkDefinition|a1 &lt;> a2 implies a1.name &lt;> a2.name) "/>
    </eAnnotations>
    <eStructuralFeatures xsi:type="ecore:EAttribute" name="name" lowerBound="1" eType="ecore:EDataType http://www.eclipse.org/emf/2002/Ecore#//EString"/>
    <eStructuralFeatures xsi:type="ecore:EReference" name="processElement" upperBound="-1"
        eType="#//ProcessElement" containment="true"/>
  </eClassifiers>
  <eClassifiers xsi:type="ecore:EClass" name="WorkDefinition" eSuperTypes="#//ProcessElement">
    <eStructuralFeatures xsi:type="ecore:EReference" name="linksToPredecessors" upperBound="-1"
        eType="#//WorkSequence" eOpposite="#//WorkSequence/successor"/>
    <eStructuralFeatures xsi:type="ecore:EReference" name="linksToSuccessors" upperBound="-1"
        eType="#//WorkSequence" eOpposite="#//WorkSequence/predecessor"/>
    <eStructuralFeatures xsi:type="ecore:EAttribute" name="name" lowerBound="1" eType="ecore:EDataType http://www.eclipse.org/emf/2002/Ecore#//EString"/>
    <eStructuralFeatures xsi:type="ecore:EReference" name="allocationressource" upperBound="-1"
        eType="#//AllocationRessource" containment="true"/>
  </eClassifiers>
  <eClassifiers xsi:type="ecore:EClass" name="WorkSequence" eSuperTypes="#//ProcessElement">
    <eAnnotations source="http://www.eclipse.org/emf/2002/Ecore">
      <details key="constraints" value="previousWDinSameProcess nextWDinSameProcess notReflexive"/>
    </eAnnotations>
    <eAnnotations source="http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot">
      <eAnnotations source="http://www.eclipse.org/emf/2002/GenModel">
        <details key="documentation" value="TP3 Ex 1.3. qu 2  Une activité ne peut pas être réflexive :"/>
      </eAnnotations>
      <details key="previousWDinSameProcess" value="self.predecessor.process = self.process"/>
      <details key="nextWDinSameProcess" value="self.successor.process = self.process"/>
      <details key="notReflexive" value="self.successor &lt;> self.predecessor"/>
    </eAnnotations>
    <eStructuralFeatures xsi:type="ecore:EAttribute" name="linkType" lowerBound="1"
        eType="#//WorkSequenceType"/>
    <eStructuralFeatures xsi:type="ecore:EReference" name="predecessor" lowerBound="1"
        eType="#//WorkDefinition" eOpposite="#//WorkDefinition/linksToSuccessors"/>
    <eStructuralFeatures xsi:type="ecore:EReference" name="successor" lowerBound="1"
        eType="#//WorkDefinition" eOpposite="#//WorkDefinition/linksToPredecessors"/>
  </eClassifiers>
  <eClassifiers xsi:type="ecore:EClass" name="ProcessElement" abstract="true">
    <eStructuralFeatures xsi:type="ecore:EReference" name="process" eType="#//Process"
        changeable="false" volatile="true" transient="true" derived="true" resolveProxies="false">
      <eAnnotations source="http://www.eclipse.org/emf/2002/GenModel">
        <details key="documentation" value="TP3 Ex 1.3. qu 2  Une activité ne peut pas être réflexive :"/>
      </eAnnotations>
      <eAnnotations source="http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot">
        <details key="derivation" value="Process.allInstances()&#xA;&#x9;&#x9;&#x9;&#x9;->select(p | p.processElement->includes(self))&#xA;&#x9;&#x9;&#x9;&#x9;->asSequence()->first()"/>
      </eAnnotations>
    </eStructuralFeatures>
  </eClassifiers>
  <eClassifiers xsi:type="ecore:EClass" name="Guidance" eSuperTypes="#//ProcessElement">
    <eStructuralFeatures xsi:type="ecore:EReference" name="elements" upperBound="-1"
        eType="#//ProcessElement"/>
    <eStructuralFeatures xsi:type="ecore:EAttribute" name="text" eType="ecore:EDataType http://www.eclipse.org/emf/2002/Ecore#//EString"/>
  </eClassifiers>
  <eClassifiers xsi:type="ecore:EClass" name="Ressource" eSuperTypes="#//ProcessElement">
    <eStructuralFeatures xsi:type="ecore:EReference" name="predecessours" upperBound="-1"
        eType="#//AllocationRessource" eOpposite="#//AllocationRessource/ressource"/>
    <eStructuralFeatures xsi:type="ecore:EAttribute" name="name" lowerBound="1" eType="ecore:EDataType http://www.eclipse.org/emf/2002/Ecore#//EString"/>
    <eStructuralFeatures xsi:type="ecore:EAttribute" name="instance" lowerBound="1"
        eType="ecore:EDataType http://www.eclipse.org/emf/2002/Ecore#//EInt"/>
  </eClassifiers>
  <eClassifiers xsi:type="ecore:EClass" name="AllocationRessource">
    <eAnnotations source="http://www.eclipse.org/emf/2002/Ecore">
      <details key="constraints" value="numAllocatedPositive numAllocatedLessThanRessourceInstance"/>
    </eAnnotations>
    <eAnnotations source="http://www.eclipse.org/emf/2002/Ecore/OCL/Pivot">
      <eAnnotations source="http://www.eclipse.org/emf/2002/GenModel">
        <details key="documentation" value="le nombre de ressource aloué ne dépasse pas de nombre d'instances de la ressours"/>
      </eAnnotations>
      <details key="numAllocatedPositive" value="self.numAllocated > 0"/>
      <details key="numAllocatedLessThanRessourceInstance" value="self.numAllocated &lt;= self.ressource.instance"/>
    </eAnnotations>
    <eStructuralFeatures xsi:type="ecore:EReference" name="ressource" lowerBound="1"
        eType="#//Ressource" eOpposite="#//Ressource/predecessours"/>
    <eStructuralFeatures xsi:type="ecore:EAttribute" name="numAllocated" lowerBound="1"
        eType="ecore:EDataType http://www.eclipse.org/emf/2002/Ecore#//EInt"/>
  </eClassifiers>
</ecore:EPackage>
